function output = DownSampling( input, scale, method )
if ~exist('method','var')
    method = 'Gaussian';
end

if scale > 1
    switch method
        case 'Gaussian'
            h = fspecial('gaussian', scale, scale);
            tmp = imfilter( input, h, 'replicate' );
            output = tmp( 1:scale:end, 1:scale:end );

        case 'Average'
            h = ones(scale,scale)/scale^2;
            tmp = conv2( input, h, 'valid' );  
            output = tmp( 1:scale:end, 1:scale:end );

        case 'Bicubic'
            output = imresize( input, 1/scale, 'bicubic' );

        case  'Nearest'
            output = input( 1:scale:end, 1:scale:end );
    end
    
elseif scale == 1
    output = input;
end