

function [mfX mfY gxx gyy] = GetMovingField_TIP( inputIm , kernelLen , scale );

    if size( inputIm , 3 ) == 3
        inputIm          = double( inputIm );
        inputIm          = inputIm./max(inputIm(:))*255;
    else
        inputIm          = double( inputIm );
        inputIm          = inputIm./max(inputIm(:))*255;
        inputIm3D        = zeros( size(inputIm,1) , size(inputIm,2) , size(inputIm,3) );
        inputIm3D(:,:,1) = inputIm;
        inputIm3D(:,:,2) = inputIm;
        inputIm3D(:,:,3) = inputIm;
        inputIm          = inputIm3D;
    end
    
    kernel          = sum(fspecial( 'gaussian' , [floor(4*kernelLen+1.5) floor(4*kernelLen+1.5)] , kernelLen ));
    [ h w ch ]      = size( inputIm );
    [gxx gyy]       = mexDisplacementCal( double(inputIm)/255 , h , w , 1 , 0.0025 );
    gxx             = imfilter( imfilter( gxx , kernel ) , kernel') ./ imfilter( imfilter( ones(size(gxx)) , kernel ) , kernel');
    gyy             = imfilter( imfilter( gyy , kernel ) , kernel') ./ imfilter( imfilter( ones(size(gyy)) , kernel ) , kernel');
    
    switch scale
        case 2
            gxx 	= gxx*1.5/max(abs(gxx(:)));
            gyy   	= gyy*1.5/max(abs(gyy(:)));
        otherwise
            gxx 	= gxx*(scale-1)*2.25/max(abs(gxx(:)));
            gyy   	= gyy*(scale-1)*2.25/max(abs(gyy(:)));
    end
    
    [ xGrid yGrid ]	= meshgrid( 1 : size( inputIm , 2 ) , 1 : size( inputIm , 1 ) ); 
   
    gxx( 1:2   , :     ) = 0;
    gxx( h-1:h , :     ) = 0;
    gxx( :     , 1:2   ) = 0;
    gxx( :     , w-1:w ) = 0;
    gyy( 1:2   , :     ) = 0;
    gyy( h-1:h , :     ) = 0;
    gyy( :     , 1:2   ) = 0;
    gyy( :     , w-1:w ) = 0;

    mfX             = xGrid-gxx;
    mfY             = yGrid-gyy;
    
end