clear all
close all

addpath('code');

%%% parameters %%%
%---------------------------------------------
  scale = 2; % 2^(scale) times upsampling
%---------------------------------------------

%%% load ground-truth %%%
depth_gt = double(imread('art.png'));

%%% make the input data %%%
depth_LR = DownSampling(depth_gt, 2^scale, 'Gaussian');    
d_max = max(depth_LR(:));
depth_LR = depth_LR/d_max; % normalization

depth_HR = depth_LR;
for j = 1:scale
    RI_guide = InterpolationMF(depth_HR, 2, 2); % upsampling via displacement field
    depth_HR = resint(depth_HR, RI_guide); % residual interpolation
end

depth_HR = depth_HR * d_max;

figure();
subplot(1,2,1); 
    imshow(uint8(depth_LR*d_max));
    title('input image');
    colormap(mycolor());

subplot(1,2,2); 
    imshow(uint8(depth_HR));
    title('output image');
    colormap(mycolor());


